library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity Multiplexer is
    Port ( 
        data_lockin : in  STD_LOGIC_VECTOR (199 downto 0); -- Data input 1
        data_trace : in  STD_LOGIC_VECTOR (199 downto 0); -- Data input 2
        dr_lockin : in  STD_LOGIC; -- lockin data ready
        dr_trace : in  STD_LOGIC; -- step data ready
        SEL   : in  STD_LOGIC; -- 1-bit select input, from CommandDecoder
        mux_out: out STD_LOGIC_VECTOR (199 downto 0); -- Output
		dr_out : out STD_LOGIC
    );
end Multiplexer;

architecture Behavioral of Multiplexer is
begin
    process(SEL, dr_lockin, dr_trace, data_lockin, data_trace)
    begin
			if (SEL = '0') then
				 mux_out <= data_lockin; -- Case 1
				 dr_out <= dr_lockin;
			else
				 mux_out <= data_trace; -- Case 2 (Default)
				 dr_out <= dr_trace;
			end if;
    end process;
end Behavioral;

--architecture Behavioral of Multiplexer is
--begin
--    process(SEL, dr_lockin, dr_trace, data_lockin, data_trace)
--    begin
--        if (dr_lockin = '1' and dr_trace = '1') then
--            if (SEL = '0') then
--                mux_out <= data_lockin; -- Case 1
--				dr_out <= dr_lockin;
--            else
--                mux_out <= data_trace; -- Case 2 (Default)
--				dr_out <= dr_trace;
--            end if;
--        else
--            mux_out <= (others => '0'); -- Default output when data is not ready
--				dr_out <= '0';
--        end if;
--    end process;
--end Behavioral;


-- entity Multiplexer is
--     Port ( 
--         data_lockin : in  STD_LOGIC_VECTOR (199 downto 0); -- Data input 1
-- 		data_trace : in  STD_LOGIC_VECTOR (199 downto 0); -- Data input 2
-- 		dr_lockin : in  STD_LOGIC; -- lockin data ready
-- 		dr_trace : in  STD_LOGIC; -- step data ready
--         SEL   : in  STD_LOGIC; -- 1-bit select input
--         mux_out: out STD_LOGIC_VECTOR (199 downto 0); -- Output
--     );
-- end Multiplexer;

-- architecture Behavioral of Multiplexer is
-- 	begin
-- 		with SEL select
-- 		mux_out <= data_lockin when '0', -- Case 1
-- 		mux_out <= data_trace when others; -- Default case
-- 	end Behavioral;
