library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity TimeCounter is
    Port (
		  clk100			: in STD_LOGIC;
        laser_data_ready : in STD_LOGIC; -- start record
        count : out STD_LOGIC_VECTOR (7 downto 0) -- counts duration between laser data points
    );
end TimeCounter;

architecture Behavioral of TimeCounter is -- need state machine?

    signal count_sig: STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
    signal last_count_sig: STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
    signal laser_data_ready_old : STD_LOGIC := '0';
    
    begin
    
    ready_prog: process(clk100)
    begin
        if rising_edge(clk100) then
            laser_data_ready_old <= laser_data_ready;
        end if;
    
    end process;
    
    count_proc: process(clk100)
    begin
        if rising_edge(clk100) then
            if (laser_data_ready_old = '0') AND (laser_data_ready = '1') then -- or the other way around?
                last_count_sig <= count_sig;
                count_sig <= (others => '0');
            else
                last_count_sig <= last_count_sig;
                count_sig <= count_sig + 1;  --TODO: first datum invalid?
            end if;
        end if;
    end process;
    
    count <= last_count_sig;
    
    end Behavioral;